public class IfThenElse extends Node implements Cmd {
	public Exp cond;
	public Bloco cthen;
	public Bloco celse;
	
	public IfThenElse(Exp _cond, Bloco _cthen, Bloco _celse, int _lin) {
		super(_lin);
		cond = _cond;
		cthen = _cthen;
		celse = _celse;
	}

	@Override
	public void checaEscopo(TabSimb<Boolean> escopo, TabSimb<Boolean> escopoProcs) {
		cond.checaEscopo(escopo, escopoProcs);
		cthen.checaEscopo(escopo, escopoProcs);
		celse.checaEscopo(escopo, escopoProcs);
	}

	@Override
	public void tipo(TabSimb<Tipo> vars) {
		Tipo tcond = cond.tipo(vars);
		if(!tcond.subtipo(Bool.tipo)) {
			throw new RuntimeException("condição do if na linha " + lin + " não é booleano, mas " + tcond);
		}
		cthen.tipo(vars);
		celse.tipo(vars);
	}
}
